JsonCpp project page | Classes | Namespace | JsonCpp home page

Json::Reader Class Reference

Unserialize a JSON document into a Value. More...

`#include <json/reader.h>`

## Classes

struct | StructuredError
| An error tagged with where in the JSON text it was encountered. More...

## Public Types

using | Char = char
using | Location = const Char*

## Public Member Functions

| Reader ()
| Constructs a Reader allowing all features for parsing.
| Reader (const Features &features)
| Constructs a Reader allowing the specified feature set for parsing.
bool | parse (const std::string &document, Value &root, bool collectComments=true)
| Read a Value from a JSON document.
bool | parse (const char *beginDoc, const char *endDoc, Value &root, bool collectComments=true)
| Read a Value from a JSON document.
bool | parse (IStream &is, Value &root, bool collectComments=true)
| Parse from input stream.
| __declspec (deprecated("Use getFormattedErrorMessages() instead.")) String getFormatedErrorMessages() const
| Returns a user friendly string that list errors in the parsed document.
String | getFormattedErrorMessages () const
| Returns a user friendly string that list errors in the parsed document.
std::vector< StructuredError > | getStructuredErrors () const
| Returns a vector of structured errors encountered while parsing.
bool | pushError (const Value &value, const String &message)
| Add a semantic error message.
bool | pushError (const Value &value, const String &message, const Value &extra)
| Add a semantic error message with extra context.
bool | good () const
| Return whether there are any errors.

## Detailed Description

Unserialize a JSON document into a Value.

Deprecated
  Use CharReader and CharReaderBuilder.

Definition at line 37 of file reader.h.

## Member Typedef Documentation

## Char

using Json::Reader::Char = char

Definition at line 39 of file reader.h.

## Location

using Json::Reader::Location = const Char*

Definition at line 40 of file reader.h.

## Constructor & Destructor Documentation

## Reader() [1/2]

Json::Reader::Reader | ( |  | ) |

Constructs a Reader allowing all features for parsing.

Deprecated
  Use CharReader and CharReaderBuilder.

Definition at line 78 of file json_reader.cpp.

## Reader() [2/2]

Json::Reader::Reader | ( | const Features & | features | ) |

Constructs a Reader allowing the specified feature set for parsing.

Deprecated
  Use CharReader and CharReaderBuilder.

Definition at line 80 of file json_reader.cpp.

## Member Function Documentation

## __declspec()

Json::Reader::__declspec | ( | deprecated("Use getFormattedErrorMessages() instead.") |  | ) | const

Returns a user friendly string that list errors in the parsed document.

Returns
  Formatted error message with the list of errors with their location in the parsed document. An empty string is returned if no error occurred during parsing.

Deprecated
  Use getFormattedErrorMessages() instead (typo fix).

References getFormattedErrorMessages(), getStructuredErrors(), good(), and pushError().

## getFormattedErrorMessages()

String Json::Reader::getFormattedErrorMessages | ( |  | ) | const

Returns a user friendly string that list errors in the parsed document.

Returns
  Formatted error message with the list of errors with their location in the parsed document. An empty string is returned if no error occurred during parsing.

Definition at line 783 of file json_reader.cpp.

Referenced by __declspec().

## getStructuredErrors()

std::vector< Reader::StructuredError > Json::Reader::getStructuredErrors | ( |  | ) | const

Returns a vector of structured errors encountered while parsing.

Returns
  A (possibly empty) vector of StructuredError objects. Currently only one error can be returned, but the caller should tolerate multiple errors. This can occur if the parser recovers from a non-fatal parse error and then encounters additional errors.

Definition at line 796 of file json_reader.cpp.

References Json::Reader::StructuredError::message, Json::Reader::StructuredError::offset_limit, and Json::Reader::StructuredError::offset_start.

Referenced by __declspec().

## good()

bool Json::Reader::good | ( |  | ) | const

Return whether there are any errors.

Returns
  `true` if there are no errors to report `false` if errors have occurred.

Definition at line 842 of file json_reader.cpp.

Referenced by __declspec().

## parse() [1/3]

bool Json::Reader::parse | ( | const char * | beginDoc,
|  | const char * | endDoc,
|  | Value & | root,
|  | bool | collectComments = true )

Read a Value from a JSON document.

Parameters

  | beginDoc | Pointer on the beginning of the UTF-8 encoded string of the document to read. The pointed-to buffer must outlive this Reader if error methods (e.g. getFormattedErrorMessages()) are called after parse() returns.
  | endDoc | Pointer on the end of the UTF-8 encoded string of the document to read. Must be >= beginDoc.
  [out] | root | Contains the root value of the document if it was successfully parsed.
  | collectComments | `true` to collect comment and allow writing them back during serialization, `false` to discard comments. This parameter is ignored if Features::allowComments_ is `false`.

Returns
  `true` if the document was successfully parsed, `false` if an error occurred.

Definition at line 97 of file json_reader.cpp.

References Json::commentAfter, Json::Value::isArray(), Json::Value::isObject(), and Json::Value::setComment().

## parse() [2/3]

bool Json::Reader::parse | ( | const std::string & | document,
|  | Value & | root,
|  | bool | collectComments = true )

Read a Value from a JSON document.

Parameters

  | document | UTF-8 encoded string containing the document to read.
  [out] | root | Contains the root value of the document if it was successfully parsed.
  | collectComments | `true` to collect comment and allow writing them back during serialization, `false` to discard comments. This parameter is ignored if Features::allowComments_ is `false`.

Returns
  `true` if the document was successfully parsed, `false` if an error occurred.

Definition at line 82 of file json_reader.cpp.

References parse().

Referenced by parse(), and parse().

## parse() [3/3]

bool Json::Reader::parse | ( | IStream & | is,
|  | Value & | root,
|  | bool | collectComments = true )

Parse from input stream.

See also
  Json::operator>>(std::istream&, Json::Value&).

Definition at line 90 of file json_reader.cpp.

References parse().

## pushError() [1/2]

bool Json::Reader::pushError | ( | const Value & | value,
|  | const String & | message )

Add a semantic error message.

Parameters

  value | JSON Value location associated with the error
  message | The error message.

Returns
  `true` if the error was successfully added, `false` if the Value offset exceeds the document size.

Definition at line 808 of file json_reader.cpp.

References Json::Value::getOffsetLimit(), and Json::Value::getOffsetStart().

Referenced by __declspec().

## pushError() [2/2]

bool Json::Reader::pushError | ( | const Value & | value,
|  | const String & | message,
|  | const Value & | extra )

Add a semantic error message with extra context.

Parameters

  value | JSON Value location associated with the error
  message | The error message.
  extra | Additional JSON Value location to contextualize the error

Returns
  `true` if the error was successfully added, `false` if either Value offset exceeds the document size.

Definition at line 824 of file json_reader.cpp.

References Json::Value::getOffsetLimit(), and Json::Value::getOffsetStart().

The documentation for this class was generated from the following files:

- include/json/reader.h
- src/lib_json/json_reader.cpp